<?php
namespace DanielGoerz\FsCodeSnippet\Enumeration;

/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project = 'inspiring people to share!
 */
use TYPO3\CMS\Core\Type\Enumeration;

/**
 * Enumeration object for supported CodeSnippetLanguages
 *
 * @author Daniel Goerz <ervaude@gmail.com>
 */
class CodeSnippetLanguage extends Enumeration
{
    const HTML = 'html';
    const XML = 'xml';
    const TYPOSCRIPT = 'typoscript';
    const MARKUP = 'markup';
    const CSS = 'css';
    const C_LIKE = 'clike';
    const JAVASCRIPT = 'javascript';
    const ABAP = 'abap';
    const ACTIONSCRIPT = 'actionscript';
    const APACHE_CONFIGURATION = 'apacheconf';
    const APL = 'apl';
    const APPLESCRIPT = 'applescript';
    const ASCIIDOC = 'asciidoc';
    const ASP_NET = 'aspnet';
    const AUTOIT = 'autoit';
    const AUTOHOTKEY = 'autohotkey';
    const BASH = 'bash';
    const BASIC = 'basic';
    const BATCH = 'batch';
    const BISON = 'bison';
    const BRAINFUCK = 'brainfuck';
    const C = 'c';
    const CSHARP = 'csharp';
    const CPP = 'cpp';
    const COFFEESCRIPT = 'coffeescript';
    const CRYSTAL = 'crystal';
    const D = 'd';
    const DART = 'dart';
    const DIFF = 'diff';
    const DOCKER = 'docker';
    const EIFFEL = 'eiffel';
    const ELIXIR = 'elixir';
    const ERLANG = 'erlang';
    const FSHARP = 'fsharp';
    const FORTRAN = 'fortran';
    const GHERKIN = 'gherkin';
    const GIT = 'git';
    const GLSL = 'glsl';
    const GO = 'go';
    const GROOVY = 'groovy';
    const HAML = 'haml';
    const HANDLEBARS = 'handlebars';
    const HASKELL = 'haskell';
    const HAXE = 'haxe';
    const HTTP = 'http';
    const ICON = 'icon';
    const INFORM_7 = 'inform7';
    const INI = 'ini';
    const J = 'j';
    const JADE = 'jade';
    const JAVA = 'java';
    const JSON = 'json';
    const JULIA = 'julia';
    const KEYMAN = 'keyman';
    const KOTLIN = 'kotlin';
    const LATEX = 'latex';
    const LESS = 'less';
    const LOLCODE = 'lolcode';
    const LUA = 'lua';
    const MAKEFILE = 'makefile';
    const MARKDOWN = 'markdown';
    const MATLAB = 'matlab';
    const MEL = 'mel';
    const MIZAR = 'mizar';
    const MONKEY = 'monkey';
    const NASM = 'nasm';
    const NGINX = 'nginx';
    const NIM = 'nim';
    const NIX = 'nix';
    const NSIS = 'nsis';
    const OBJECTIVE_C = 'objectivec';
    const OCAML = 'ocaml';
    const OZ = 'oz';
    const PARI_GP = 'parigp';
    const PARSER = 'parser';
    const PASCAL = 'pascal';
    const PERL = 'perl';
    const PHP = 'php';
    const POWERSHELL = 'powershell';
    const PROCESSING = 'processing';
    const PROLOG = 'prolog';
    const PUPPET = 'puppet';
    const PURE = 'pure';
    const PYTHON = 'python';
    const Q = 'q';
    const QORE = 'qore';
    const R = 'r';
    const REACT_JSX = 'jsx';
    const REST = 'rest';
    const RIP = 'rip';
    const ROBOCONF = 'roboconf';
    const RUBY = 'ruby';
    const RUST = 'rust';
    const SAS = 'sas';
    const SASS_SASS = 'sass';
    const SASS_SCSS = 'scss';
    const SCALA = 'scala';
    const SCHEME = 'scheme';
    const SMALLTALK = 'smalltalk';
    const SMARTY = 'smarty';
    const SQL = 'sql';
    const STYLUS = 'stylus';
    const SWIFT = 'swift';
    const TCL = 'tcl';
    const TEXTILE = 'textile';
    const TWIG = 'twig';
    const TYPESCRIPT = 'typescript';
    const VERILOG = 'verilog';
    const VHDL = 'vhdl';
    const VIM = 'vim';
    const WIKI_MARKUP = 'wiki';
    const YAML = 'yaml';

    const COMMANDLINE = 'commandline';
}
